module wei_down_type
  use wei_util
  use wei_type


   type weidown
     character(len=128) ::  VS,VG, D, R, W,U !! file tags
     character(len=128) :: dS,   dR,mod_,dat_
     character(len=128) :: order
     character(len=128) :: image_lock
     integer            :: image_lock_fd
     logical            :: adj, add
     logical            :: shot_profile
     integer            :: opsign
     !! simultate conjg(phase) to avoid 'if'
     !! opsign=goB2T (e.g.  modeling)
     !! opsign=goT2B (e.g. migration)
     integer            :: nzs     !! number of depth     slices in a block
     integer            :: nws     !! number of frequency slices in a block
     integer            :: nzb     !! number of depth     blocks
     integer            :: nwb     !! local  number of frequency blocks
     integer            :: nwp     !! global  number of frequency block
     integer            :: nref    !! number of  reference velocities
     logical            :: conv_wave !! whether or not we are doing converted wave velocity
     integer,pointer    :: iw_thread(:) !! which mpi thread  each
     integer,pointer    :: iw_first(:)  ! First actual iw in each block
     real, pointer      :: freqs(:,:)   ! (nth,nws) Frequencies
     integer            :: nw_local     ! Number of local frequencies
     integer,pointer    :: iz_write(:)  ! First z block to write
     logical            :: pCIG
     logical            :: maxslow       !Use maximum slowness
     type(weslow)       :: S       !! Slowness 
     type(sep3d)        :: Wsep       !!Down   parameters (mx,my,hx,hy,nzs,nws)
     type(sep3d)        :: Rsep       !!Image  parameters (mx,my,hx,hy,z,w)
     type(sep3d)        :: Dsep       !!Data   parameters (mx,my,hx,hy,w)
     type(sep3d)        :: Ssep       !!Slow   parameters (mx,my,z)
     type(sep3d)        :: S2sep      !!Slow   parameters (mx,my,z)
     complex, pointer   :: block(:,:,:,:,:)
    real, pointer       :: max_slow(:) 
    real, pointer       :: w_local(:),wt_local(:),wts(:,:)
  end type weidown
 !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!
  type(weidown), public :: down
  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!



end module
