module wei_timers_mod

#ifdef SEP_TIMER
  use sep_timers_mod
#endif
implicit none

type weitimer 
     integer            :: init_t
     integer            :: io_t
     integer            :: distrib_t
     integer            :: kxmig_t
     integer            :: fk_t
     integer            :: fx_t
     integer            :: fft_t
     integer            :: fftw_t
     integer            :: image_t
     integer            :: slow_t
     integer            :: collect_t
     integer            :: s_dis_t
     integer            :: diskio_t
     integer            :: junk1_t,junk2_t,junk3_t,junk4_t,junk5_t,junk6_t
end type

type(weitimer)  :: timer

contains




logical function init_wei_timers(   )
logical :: junkl
#ifdef DEBUG
    character(len=128), parameter :: unit='weimig_init'
    call in(unit)
#endif


#ifdef SEP_TIMER
    junkl= init_sep_timers()
      junkl=setup_next_timer("INIT",timer%init_t)
         junkl=setup_next_timer("IO",timer%io_t)
         junkl=setup_next_timer("DISTRIBUTION",timer%distrib_t)
         junkl=setup_next_timer("KXMIG",timer%kxmig_t)
         junkl=setup_next_timer("FK",timer%fk_t)
         junkl=setup_next_timer("FX",timer%fx_t)
         junkl=setup_next_timer("FFT",timer%fft_t)
!         junkl=setup_next_timer("FFTW",timer%fftw_t)
         junkl=setup_next_timer("SLOW SELLECT",timer%slow_t)
         junkl=setup_next_timer("COLLECT",timer%collect_t)
         junkl=setup_next_timer("IMAGE",timer%image_t)
         junkl=setup_next_timer("INITIAL IMAGE",timer%junk1_t)
         junkl=setup_next_timer("SAVES",timer%junk2_t)
         junkl=setup_next_timer("READ",timer%junk3_t)
         junkl=setup_next_timer("WRITE",timer%junk4_t)
         junkl=setup_next_timer("SREED",timer%junk5_t)
         junkl=setup_next_timer("SRITE",timer%junk6_t)
#endif



#ifdef DEBUG
    call out(unit)
#endif


init_wei_timers=.true.  
end function




end module
