!!$
!!$ Module containing all of the external variables and constants
!!$  in wei
!!$
!!$
!!$
module wei_external

  !SEPlib externals
  integer, external :: getch,sreed,srite,sseek,sseek_block,auxin

  !MPI EXTERNALS
#ifdef SEP_MPI
  integer, external :: mpi_sep_tag_sum_index,mpi_sep_create_group
  integer, external :: mpi_sep_tag_bcast_index
  integer, external :: mpi_sep_tag_sum,mpi_sep_open_lock
  integer, external :: mpi_sep_tag_bcast
  integer, external :: mpi_sep_tag_combine
  integer, external :: mpi_sep_tag_distribute
  integer, external :: mpi_sep_check_lock
#endif

  !OMP EXTERNALS
#ifdef SEP_OMP
  integer, external :: omp_get_thread_num
  integer, external :: omp_get_num_threads
#endif
  real, public    :: pi=3.1415926536
  integer, public :: OK=1
  integer, public :: weiB2T=+1,weiT2B=-1
  integer, public :: goB2T=+1,goT2B=-1
  logical, public  :: T=.true.,F=.false.


end module
