
module wei_mem_mod
use weirun_type_mod
use sep
implicit none
integer, private, save :: mem_usage
logical, private, save :: verb_mem_usage

contains

  logical function init_mem_usage()

    call from_param('mem_monitor', verb_mem_usage, .false.)
    mem_usage=0
    init_mem_usage=.true.

  end function

   subroutine del_mem(iadd)
    integer  :: iadd
      mem_usage=mem_usage-iadd
   end subroutine

   subroutine show_mem(str)
    character(len=*) :: str
     if(run%verb .and. verb_mem_usage) &
      write(0,*) "memory used (mb) ",trim(str),":",real(mem_usage)*8./1000000.
   end subroutine

   subroutine add_mem(iadd)
    integer  :: iadd
      mem_usage=mem_usage+iadd
   end subroutine

end module
