module weirun_type_mod

  type weirun
     character(len=4)   :: tag_num
     character(len=9)   :: mach
     character(len=128) :: operator,logfile
     character(len=128) :: operation,file_out,local_path
     logical            :: verb_all !! verbose
     logical            :: verb    !! verbose
     logical            :: debug   !! Debug
     logical            :: depar   !! debug in the parallel regions
     logical            :: restart !! whether or not we are restarting the job
     logical            :: omp,mpi !! whether or not this is an omp/mpi job
     logical            :: share_image !! share image file
     integer            :: io_unit !! unit to write out verb info
     integer            :: m_ith!! mpi thread number
     integer            :: m_nth !! number of mpi threads
     integer            :: o_nth !! number of omp threads
     integer            :: fk_extra !! number of extra wavefields copies needed by fk op
     integer            :: mem_save !! whether to try to save memory
                          !0-none(default),1-no slowness arrays
                          !2-1 extra wavefield 3-2-extra wavefields
     logical            :: unlink
  end type weirun

  type(weirun) :: run

end module
